﻿Type=Service
Version=6.5
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	'Jose Sanchez jsanchezc1960@gmail.com
     Dim Notify As Notification
	 Dim SQL1 As SQL 
	 Dim FTPImagenes As FTP
	 Dim Destino As String =""
     Dim DirOrigen As String=""
     Dim xFilename As String=""
     Dim Idx As String="0"
	 Dim Tmrx As Timer 
	 Dim FileObserver1 As FileObserver
	 Dim RetryDone As Int=0
	 'Estas variables deberían estar en configuración de la app
	 Dim PathPhotos As String =""
	Dim FTPServer As String= "ftp.xxxxxxxx.com"
	Dim FTPPort As String="21"
	Dim FTPUser As String="xxxxx@xxxxxxxx.com"
	Dim FTPPwd As String="xxxxxxxx"
End Sub
Sub Service_Create
	PathPhotos=File.DirRootExternal & "/DCIM/Camera"
    Notify.Initialize
    Notify.Sound = False
    Notify.Vibrate = False
	Notify.Notify( 1)
    Notify.Icon = "icon"
	Notify.SetInfo ( "JSynC" ,"JSynC started",Main)
	Notify.Notify(1 )
	Notify.Icon = "icon"
	FileObserver1.Initialize("FileObserver1", PathPhotos  )
	Tmrx.Initialize ("Tmrx",5000 )
	Tmrx.Enabled =True 
End Sub
Sub Tmrx_Tick
   Tmrx.Enabled =False
   SendFiles
End Sub
Sub Service_Start (StartingIntent As Intent)
   Service.StartForeground ( 1,Notify)
   FileObserver1.StartWatching
	
End Sub




Sub SendFiles
   Dim SQLString As String =""
   Dim DRX As Cursor 
   Dim i As Int=0
   Dim InfoData As String=""
    Notify.SetInfo("JSynC","Uploading file ... " , "" )
   If SQL1.IsInitialized=False Then
      SQL1.Initialize (File.DirDefaultExternal & "/data","jsc.sqlite",False)
   End If
   SQLString="SELECT idx,fFilePath,fFileName from jsc_q where fint=0 order by fDatetime desc"
   DRX=SQL1.ExecQuery ( SQLString )
   If DRX.RowCount >0 Then
       DRX.Position =0
       'For i=0 To DRX.RowCount -1
	      Idx=DRX.GetString("idx")
		Notify.SetInfo("JSynC","Uploading file ... " & Idx , "" )
	   	  DirOrigen=DRX.GetString("fFilePath")
	      xFilename=DRX.GetString("fFileName")
	      Destino= "/"  & xFilename.Replace("_","") 
          Try
  	        If FTPImagenes.IsInitialized=False Then 
                FTPImagenes.Initialize(  "FTPImagenesList" ,FTPServer, FTPPort,  FTPUser, FTPPwd )
				FTPImagenes.PassiveMode =True 
            End If
	      Catch
            Log (LastException.Message )
			ToastMessageShow(LastException.message,False )
          End Try
          Try
			If File.Exists (DirOrigen,xFilename)=True Then
   	           FTPImagenes.UploadFile( DirOrigen,xFilename,  False,  Destino   )
				InfoData="Enviando imagen (" & (RetryDone+1) & ")" & xFilename
			   ToastMessageShow(InfoData,False ) 
			   Else
				If SQL1.IsInitialized=False Then
					SQL1.Initialize (File.DirDefaultExternal & "/data","jsc.sqlite",False)
				End If
				SQLString="update jsc_q set fint=1 where idx='" & Idx & "'"
				SQL1.ExecNonQuery(SQLString)
			End If 
			RetryDone=0
			Tmrx.Interval =10000
	      Catch
            Log (LastException.Message )
			ToastMessageShow(LastException.message,False )
	        Try
	          FTPImagenes.CloseNow 
		    Catch
              Log (LastException.Message )
				ToastMessageShow(LastException.message,False )
			End Try
			If RetryDone < 6 Then
				RetryDone=RetryDone+1
				Tmrx.Interval =10000
				Tmrx.Enabled =True
			Else
				
			    Tmrx.Interval =20000
				Tmrx.Enabled =True
			End If
		 End Try
       'Next
  Else
	RetryDone=0
     Notify.SetInfo("JSynC","Waiting for new files ... " , "" )
	 Tmrx.Interval=30000
     Tmrx.Enabled =True 
  End If
 Tmrx.Enabled =True 
End Sub

Sub FTPImagenesList_UploadCompleted (ServerPath As String, Success As Boolean)
    Dim SQLString As String =""
	If Success=True Then
	   ToastMessageShow("Upload completed " & xFilename,False ) 
	   If  Destino<> "" And DirOrigen<> "" And xFilename<> "" And Idx <> "0" Then
	       If SQL1.IsInitialized=False Then
              SQL1.Initialize (File.DirDefaultExternal & "/data","jsc.sqlite",False)
           End If
		   SQLString="update jsc_q set fint=1 where idx='" & Idx & "'"
		   SQL1.ExecNonQuery(SQLString)
		   Notify.SetInfo("JSynC","Datos enviados ... " & Idx, "" )
		    
			Destino= "" 
			DirOrigen= "" 
			xFilename= "" 
			Idx = "0"
			
			SendFiles
		
		Else
		  Tmrx.Interval =10000
		  Tmrx.Enabled =True
		End If
	Else
	       
	        Try
	          FTPImagenes.CloseNow 
		    Catch
              Log (LastException.Message )
			ToastMessageShow(LastException.message,False )
            End Try
			Tmrx.Interval =10000
		    Tmrx.Enabled =True
	End If
	 Tmrx.Enabled =True 
End Sub 
Sub Service_Destroy
	FileObserver1.StopWatching
Tmrx.Enabled=False 
Try
  SQL1.close
Catch
  Log(LastException.Message )  
End Try  
Try
   FTPImagenes.CloseNow 
Catch
  Log(LastException.Message )  
End Try  
Try
   Service.StopForeground (1)
Catch
		Log(LastException.Message )
	End Try
   
End Sub


Sub EnviarFile(sFileName As String)
	Dim SqlString As String=""
	Dim DateInsert As String =""
	DateTime.DateFormat="yyyyMMddHHmmss"
	DateInsert=DateTime.Date( DateTime.Now)
	
	If Main.SQL1.IsInitialized=False Then
		Main.SQL1.Initialize (File.DirDefaultExternal & "/data","jsc.sqlite",False)
	End If
	'===========================================
	'Insertar en la cola de procesos
	'===========================================
	SqlString=""
	SqlString=SqlString & "INSERT INTO jsc_q "
	SqlString=SqlString & "(fDateTime "
	SqlString=SqlString & ",fFilePath "
	SqlString=SqlString & ",fFileName "
	SqlString=SqlString & ",fInt "
	SqlString=SqlString & ") "
	SqlString=SqlString & " Values "
	SqlString=SqlString & "('" & DateInsert & "'"
	SqlString=SqlString & ",'" & PathPhotos & "'"
	SqlString=SqlString & ",'" & sFileName & "'"
	SqlString=SqlString & ",'0'"
	SqlString=SqlString & ")"
	SQL1.ExecNonQuery(SqlString )
	ToastMessageShow("Image saved: " & File.Combine(PathPhotos, sFileName), False)
	Tmrx.Interval =10000
	
	
End Sub
Sub FileObserver1_OnEvent (EventType As Int, Path As String)

	Log("EventType="&FileObserver1.EventTypeToString(EventType)&", Path="& Path)
	
	Select EventType
		Case FileObserver1.ACCESS
			'	handle event
		Case FileObserver1.ATTRIB
			'	handle event
		Case FileObserver1.CLOSE_NOWRITE
			'	handle event
		Case FileObserver1.CLOSE_WRITE
			'	handle event
		Case FileObserver1.CREATE
			'	handle event
			EnviarFile(Path) 
			Log("EventType=" & FileObserver1.EventTypeToString(EventType)& ", Path=" & Path)
			
		Case FileObserver1.DELETE
			'	handle event
		Case FileObserver1.DELETE_SELF
			'	handle event
		Case FileObserver1.MODIFY
			'	handle event
		Case FileObserver1.MOVE_SELF
			'	handle event
		Case FileObserver1.MOVED_FROM
			'	handle event
		Case FileObserver1.MOVED_TO
			'	handle event
		Case FileObserver1.OPEN
			'	handle event
	End Select
End Sub
